/* mpld3.js: javascript backend for displaying interactive matplotlib plots *//*   Author: Jake Vanderplas                                                *//*   License: 3-clause BSD (see http://github.com/jakevdp/mpld3)            *//*                                                                          *//* Notes:                                                                   *//* - the objects here use prototype-based definitions rather than           *//*   closure-based definitions for the sake of memory efficiency.           *//*                                                                          *//* - this assumes that d3 is defined in the global namespace, and the       *//*   result is that mpld3 is defined in the global namespace.               *//*                                                                          */!function(e) {
  function n(e) {
    var t = {};
    for (var n in e) t[n] = e[n];
    return t;
  }
  function r(e, t) {
    e = typeof e != "undefined" ? e : 10, t = typeof t != "undefined" ? t : "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
    var n = t.charAt(Math.round(Math.random() * (t.length - 11)));
    for (var r = 1; r < e; r++) n += t.charAt(Math.round(Math.random() * (t.length - 1)));
    return n;
  }
  function i(t, n) {
    var r = e.interpolate([ t[0].valueOf(), t[1].valueOf() ], [ n[0].valueOf(), n[1].valueOf() ]);
    return function(e) {
      var t = r(e);
      return [ new Date(t[0]), new Date(t[1]) ];
    };
  }
  function s(e) {
    return typeof e == "undefined";
  }
  function o(e) {
    return e == null || s(e);
  }
  function u(e, t) {
    return e.length > 0 ? e[t % e.length] : null;
  }
  function a(t) {
    function o(t, o) {
      var u = e.functor(n), a = e.functor(r), f = [], l = [], c = 0, h = -1, p = 0, d = !1;
      if (!o) {
        o = [ "M" ];
        for (var v = 1; v < t.length; v++) o.push("L");
      }
      while (++h < o.length) {
        p = c + s[o[h]], f = [];
        while (c < p) i.call(this, t[c], c) ? (f.push(u.call(this, t[c], c), a.call(this, t[c], c)), c++) : (f = null, c = p);
        f ? d && f.length > 0 ? (l.push("M", f[0], f[1]), d = !1) : (l.push(o[h]), l = l.concat(f)) : d = !0;
      }
      return c != t.length && console.warn("Warning: not all vertices used in Path"), l.join(" ");
    }
    var n = function(e, t) {
      return e[0];
    }, r = function(e, t) {
      return e[1];
    }, i = function(e, t) {
      return !0;
    }, s = {
      M: 1,
      m: 1,
      L: 1,
      l: 1,
      Q: 2,
      q: 2,
      T: 1,
      t: 1,
      S: 2,
      s: 2,
      C: 3,
      c: 3,
      Z: 0,
      z: 0
    };
    return o.x = function(e) {
      return arguments.length ? (n = e, o) : n;
    }, o.y = function(e) {
      return arguments.length ? (r = e, o) : r;
    }, o.defined = function(e) {
      return arguments.length ? (i = e, o) : i;
    }, o.call = o, o;
  }
  function f(e) {
    function r(e) {
      return t.forEach(function(t) {
        e = t(e);
      }), e;
    }
    var t = Array.prototype.slice.call(arguments, 0), n = t.length;
    return r.domain = function(e) {
      return arguments.length ? (t[0].domain(e), r) : t[0].domain();
    }, r.range = function(e) {
      return arguments.length ? (t[n - 1].range(e), r) : t[n - 1].range();
    }, r.step = function(e) {
      return t[e];
    }, r;
  }
  function l(e, t) {
    O.call(this, e, t), this.cssclass = "mpld3-" + this.props.xy + "grid";
    if (this.props.xy == "x") this.transform = "translate(0," + this.ax.height + ")", this.position = "bottom", this.scale = this.ax.xdom, this.tickSize = -this.ax.height; else {
      if (this.props.xy != "y") throw "unrecognized grid xy specifier: should be 'x' or 'y'";
      this.transform = "translate(0,0)", this.position = "left", this.scale = this.ax.ydom, this.tickSize = -this.ax.width;
    }
  }
  function c(e, t) {
    O.call(this, e, t);
    var n = {
      bottom: [ 0, this.ax.height ],
      top: [ 0, 0 ],
      left: [ 0, 0 ],
      right: [ this.ax.width, 0 ]
    }, r = {
      bottom: "x",
      top: "x",
      left: "y",
      right: "y"
    };
    this.transform = "translate(" + n[this.props.position] + ")", this.props.xy = r[this.props.position], this.cssclass = "mpld3-" + this.props.xy + "axis", this.scale = this.ax[this.props.xy + "dom"];
  }
  function h(e, t) {
    if (typeof t == "undefined") {
      this.ax = null, this.fig = null;
      if (this.trans !== "display") throw "ax must be defined if transform != 'display'";
    } else this.ax = t, this.fig = t.fig;
    this.zoomable = e === "data", this.x = this["x_" + e], this.y = this["y_" + e];
    if (typeof this.x == "undefined" || typeof this.y == "undefined") throw "unrecognized coordinate code: " + e;
  }
  function p(e, t) {
    O.call(this, e, t), this.data = e.fig.get_data(this.props.data), this.pathcodes = this.props.pathcodes, this.pathcoords = new h(this.props.coordinates, this.ax), this.offsetcoords = new h(this.props.offsetcoordinates, this.ax), this.datafunc = a();
  }
  function d(e, t) {
    O.call(this, e, t);
    if (this.props.facecolors == null || this.props.facecolors.length == 0) this.props.facecolors = [ "none" ];
    if (this.props.edgecolors == null || this.props.edgecolors.length == 0) this.props.edgecolors = [ "none" ];
    var n = this.ax.fig.get_data(this.props.offsets);
    if (n === null || n.length === 0) n = [ null ];
    var r = Math.max(this.props.paths.length, n.length);
    if (n.length === r) this.offsets = n; else {
      this.offsets = [];
      for (var i = 0; i < r; i++) this.offsets.push(u(n, i));
    }
    this.pathcoords = new h(this.props.pathcoordinates, this.ax), this.offsetcoords = new h(this.props.offsetcoordinates, this.ax);
  }
  function v(t, n) {
    O.call(this, t, n);
    var r = this.props;
    r.facecolor = "none", r.edgecolor = r.color, delete r.color, r.edgewidth = r.linewidth, delete r.linewidth, this.defaultProps = p.prototype.defaultProps, p.call(this, t, r), this.datafunc = e.svg.line().interpolate("linear");
  }
  function m(n, r) {
    O.call(this, n, r), this.props.markerpath !== null ? this.marker = this.props.markerpath[0].length == 0 ? null : t.path().call(this.props.markerpath[0], this.props.markerpath[1]) : this.marker = this.props.markername === null ? null : e.svg.symbol(this.props.markername).size(Math.pow(this.props.markersize, 2))();
    var i = {
      paths: [ this.props.markerpath ],
      offsets: n.fig.get_data(this.props.data),
      xindex: this.props.xindex,
      yindex: this.props.yindex,
      offsetcoordinates: this.props.coordinates,
      edgecolors: [ this.props.edgecolor ],
      edgewidths: [ this.props.edgewidth ],
      facecolors: [ this.props.facecolor ],
      alphas: [ this.props.alpha ],
      zorder: this.props.zorder,
      id: this.props.id
    };
    this.requiredProps = d.prototype.requiredProps, this.defaultProps = d.prototype.defaultProps, d.call(this, n, i);
  }
  function g(e, t) {
    O.call(this, e, t), this.coords = new h(this.props.coordinates, this.ax);
  }
  function y(e, t) {
    O.call(this, e, t), this.text = this.props.text, this.position = this.props.position, this.coords = new h(this.props.coordinates, this.ax);
  }
  function b(n, r) {
    function s(e) {
      return new Date(e[0], e[1], e[2], e[3], e[4], e[5]);
    }
    function o(e, t) {
      return e !== "date" ? t : [ s(t[0]), s(t[1]) ];
    }
    function u(t, n, r) {
      var i = t === "date" ? e.time.scale() : t === "log" ? e.scale.log() : e.scale.linear();
      return i.domain(n).range(r);
    }
    O.call(this, n, r), this.axnum = this.fig.axes.length, this.axid = this.fig.figid + "_ax" + (this.axnum + 1), this.clipid = this.axid + "_clip", this.props.xdomain = this.props.xdomain || this.props.xlim, this.props.ydomain = this.props.ydomain || this.props.ylim, this.sharex = [], this.sharey = [], this.elements = [];
    var i = this.props.bbox;
    this.position = [ i[0] * this.fig.width, (1 - i[1] - i[3]) * this.fig.height ], this.width = i[2] * this.fig.width, this.height = i[3] * this.fig.height, this.props.xdomain = o(this.props.xscale, this.props.xdomain), this.props.ydomain = o(this.props.yscale, this.props.ydomain), this.x = this.xdom = u(this.props.xscale, this.props.xdomain, [ 0, this.width ]), this.y = this.ydom = u(this.props.yscale, this.props.ydomain, [ this.height, 0 ]), this.props.xscale === "date" && (this.x = t.multiscale(e.scale.linear().domain(this.props.xlim).range(this.props.xdomain.map(Number)), this.xdom)), this.props.yscale === "date" && (this.x = t.multiscale(e.scale.linear().domain(this.props.ylim).range(this.props.ydomain.map(Number)), this.ydom));
    var a = this.props.axes;
    for (var f = 0; f < a.length; f++) {
      var l = new t.Axis(this, a[f]);
      this.elements.push(l), (this.props.gridOn || l.props.grid.gridOn) && this.elements.push(l.getGrid());
    }
    var c = this.props.paths;
    for (var f = 0; f < c.length; f++) this.elements.push(new t.Path(this, c[f]));
    var h = this.props.lines;
    for (var f = 0; f < h.length; f++) this.elements.push(new t.Line(this, h[f]));
    var p = this.props.markers;
    for (var f = 0; f < p.length; f++) this.elements.push(new t.Markers(this, p[f]));
    var d = this.props.texts;
    for (var f = 0; f < d.length; f++) this.elements.push(new t.Text(this, d[f]));
    var v = this.props.collections;
    for (var f = 0; f < v.length; f++) this.elements.push(new t.PathCollection(this, v[f]));
    var m = this.props.images;
    for (var f = 0; f < m.length; f++) this.elements.push(new t.Image(this, m[f]));
    this.elements.sort(function(e, t) {
      return e.props.zorder - t.props.zorder;
    });
  }
  function w(e, t) {
    O.call(this, e, t), this.buttons = [], this.props.buttons.forEach(this.addButton.bind(this));
  }
  function E(e, t) {
    O.call(this, e), this.toolbar = e, this.fig = this.toolbar.fig, this.cssclass = "mpld3-" + t + "button", this.active = !1;
  }
  function S(e, t) {
    O.call(this, e, t);
  }
  function x(e, n) {
    S.call(this, e, n);
    var r = t.ButtonFactory({
      buttonID: "reset",
      sticky: !1,
      onActivate: function() {
        this.toolbar.fig.reset();
      },
      icon: function() {
        return t.icons.reset;
      }
    });
    this.fig.buttons.push(r);
  }
  function T(e, n) {
    S.call(this, e, n), this.props.enabled === null && (this.props.enabled = !this.props.button);
    var r = this.props.enabled;
    if (this.props.button) {
      var i = t.ButtonFactory({
        buttonID: "zoom",
        sticky: !0,
        actions: [ "scroll", "drag" ],
        onActivate: this.activate.bind(this),
        onDeactivate: this.deactivate.bind(this),
        onDraw: function() {
          this.setState(r);
        },
        icon: function() {
          return t.icons.move;
        }
      });
      this.fig.buttons.push(i);
    }
  }
  function N(e, n) {
    S.call(this, e, n), this.props.enabled === null && (this.props.enabled = !this.props.button);
    var r = this.props.enabled;
    if (this.props.button) {
      var i = t.ButtonFactory({
        buttonID: "boxzoom",
        sticky: !0,
        actions: [ "drag" ],
        onActivate: this.activate.bind(this),
        onDeactivate: this.deactivate.bind(this),
        onDraw: function() {
          this.setState(r);
        },
        icon: function() {
          return t.icons.zoom;
        }
      });
      this.fig.buttons.push(i);
    }
    this.extentClass = "boxzoombrush";
  }
  function C(e, t) {
    S.call(this, e, t);
  }
  function k(e, n) {
    t.Plugin.call(this, e, n), this.props.enabled === null && (this.props.enabled = !this.props.button);
    var r = this.props.enabled;
    if (this.props.button) {
      var i = t.ButtonFactory({
        buttonID: "linkedbrush",
        sticky: !0,
        actions: [ "drag" ],
        onActivate: this.activate.bind(this),
        onDeactivate: this.deactivate.bind(this),
        onDraw: function() {
          this.setState(r);
        },
        icon: function() {
          return t.icons.brush;
        }
      });
      this.fig.buttons.push(i);
    }
    this.extentClass = "linkedbrush";
  }
  function L(e, n) {
    t.Plugin.call(this, e, n);
  }
  function A(n, r) {
    O.call(this, null, r), this.figid = n, this.width = this.props.width, this.height = this.props.height, this.data = this.props.data, this.buttons = [], this.root = e.select("#" + n).append("div").style("position", "relative"), this.axes = [];
    for (var i = 0; i < this.props.axes.length; i++) this.axes.push(new b(this, this.props.axes[i]));
    this.plugins = [];
    for (var i = 0; i < this.props.plugins.length; i++) this.add_plugin(this.props.plugins[i]);
    this.toolbar = new t.Toolbar(this, {
      buttons: this.buttons
    });
  }
  function O(e, t) {
    this.parent = o(e) ? null : e, this.props = o(t) ? {} : this.processProps(t), this.fig = e instanceof A ? e : e && "fig" in e ? e.fig : null, this.ax = e instanceof b ? e : e && "ax" in e ? e.ax : null;
  }
  var t = {
    _mpld3IsLoaded: !0,
    figures: [],
    plugin_map: {}
  };
  t.version = "0.3git", t.register_plugin = function(e, n) {
    t.plugin_map[e] = n;
  }, t.draw_figure = function(e, n) {
    var r = document.getElementById(e);
    if (r === null) throw e + " is not a valid id";
    var i = new t.Figure(e, n);
    return t.figures.push(i), i.draw(), i;
  }, t.cloneObj = n, t.merge_objects = function(e) {
    var t = {}, n;
    for (var r = 0; r < arguments.length; r++) {
      n = arguments[r];
      for (var i in n) t[i] = n[i];
    }
    return t;
  }, t.generate_id = function(e, t) {
    return console.warn("mpld3.generate_id is deprecated. Use mpld3.generateId instead."), r(e, t);
  }, t.generateId = r, t.get_element = function(e, n) {
    var r, i, s;
    typeof n == "undefined" ? r = t.figures : typeof n.length == "undefined" ? r = [ n ] : r = n;
    for (var o = 0; o < r.length; o++) {
      n = r[o];
      if (n.props.id === e) return n;
      for (var u = 0; u < n.axes.length; u++) {
        i = n.axes[u];
        if (i.props.id === e) return i;
        for (var a = 0; a < i.elements.length; a++) {
          s = i.elements[a];
          if (s.props.id === e) return s;
        }
      }
    }
    return null;
  }, t.insert_css = function(e, t) {
    var n = document.head || document.getElementsByTagName("head")[0], r = document.createElement("style"), i = e + " {";
    for (var s in t) i += s + ":" + t[s] + "; ";
    i += "}", r.type = "text/css", r.styleSheet ? r.styleSheet.cssText = i : r.appendChild(document.createTextNode(i)), n.appendChild(r);
  }, t.process_props = function(e, t, n, r) {
    function i(e) {
      O.call(this, null, e);
    }
    console.warn("mpld3.process_props is deprecated. Plot elements should derive from mpld3.PlotElement"), i.prototype = Object.create(O.prototype), i.prototype.constructor = i, i.prototype.requiredProps = r, i.prototype.defaultProps = n;
    var s = new i(t);
    return s.props;
  }, t.interpolateDates = i, t.path = function() {
    return a();
  }, t.multiscale = f, t.icons = {
    reset: "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABmJLR0QA/wD/AP+gvaeTAAAACXBI\nWXMAAAsTAAALEwEAmpwYAAAAB3RJTUUH3gIcACMoD/OzIwAAAJhJREFUOMtjYKAx4KDUgNsMDAx7\nyNV8i4GB4T8U76VEM8mGYNNMtCH4NBM0hBjNMIwSsMzQ0MamcDkDA8NmQi6xggpUoikwQbIkHk2u\nE0rLI7vCBknBSyxeRDZAE6qHgQkq+ZeBgYERSfFPAoHNDNUDN4BswIRmKgxwEasP2dlsDAwMYlA/\n/mVgYHiBpkkGKscIDaPfVMmuAGnOTaGsXF0MAAAAAElFTkSuQmCC\n",
    move: "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABmJLR0QA/wD/AP+gvaeTAAAACXBI\nWXMAAAsTAAALEwEAmpwYAAAAB3RJTUUH3gIcACQMfLHBNQAAANZJREFUOMud07FKA0EQBuAviaKB\nlFr7COJrpAyYRlKn8hECEkFEn8ROCCm0sBMRYgh5EgVFtEhsRjiO27vkBoZd/vn5d3b+XcrjFI9q\nxgXWkc8pUjOB93GMd3zgB9d1unjDSxmhWSHQqOJki+MtOuv/b3ZifUqctIrMxwhHuG1gim4Ma5kR\nWuEkXFgU4B0MW1Ho4TeyjX3s4TDq3zn8ALvZ7q5wX9DqLOHCDA95cFBAnOO1AL/ZdNopgY3fQcqF\nyriMe37hM9w521ZkkvlMo7o/8g7nZYQ/QDctp1nTCf0AAAAASUVORK5CYII=\n",
    zoom: "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABmJLR0QA/wD/AP+gvaeTAAAACXBI\nWXMAAAsTAAALEwEAmpwYAAAAB3RJTUUH3gMPDiIRPL/2oQAAANBJREFUOMvF0b9KgzEcheHHVnCT\nKoI4uXbtLXgB3oJDJxevw1VwkoJ/NjepQ2/BrZRCx0ILFURQKV2kyOeSQpAmn7WDB0Lg955zEhLy\n2scdXlBggits+4WOQqjAJ3qYR7NGLrwXGU9+sGbEtlIF18FwmuBngZ+nCt6CIacC3Rx8LSl4xzgF\nn0tusBn4UyVhuA/7ZYIv5g+pE3ail25hN/qdmzCfpsJVjKKCZesDBwtzrAqGOMQj6vhCDRsY4ALH\nmOVObltR/xeG/jph6OD2r+Fv5lZBWEhMx58AAAAASUVORK5CYII=\n",
    brush: "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABmJLR0QA/wD/AP+gvaeTAAAACXBI\nWXMAAEQkAABEJAFAZ8RUAAAAB3RJTUUH3gMCEiQKB9YaAgAAAWtJREFUOMuN0r1qVVEQhuFn700k\nnfEvBq0iNiIiOKXgH4KCaBeIhWARK/EibLwFCwVLjyAWaQzRGG9grC3URkHUBKKgRuWohWvL5pjj\nyTSLxcz7rZlZHyMiItqzFxGTEVF18/UoODNFxDIO4x12dkXqTcBPsCUzD+AK3ndFqhHwEsYz82gn\nN4dbmMRK9R/4KY7jAvbiWmYeHBT5Z4QCP8J1rGAeN3GvU3Mbl/Gq3qCDcxjLzOV+v78fq/iFIxFx\nPyJ2lNJpfBy2g59YzMyzEbEVLzGBJjOriLiBq5gaJrCIU3hcRCbwAtuwjm/Yg/V6I9NgDA1OR8RC\nZq6Vcd7iUwtn5h8fdMBdETGPE+Xe4ExELDRNs4bX2NfCUHe+7UExyfkCP8MhzOA7PuAkvrbwXyNF\nxF3MDqxiqlhXC7SPdaOKiN14g0u4g3H0MvOiTUSNY3iemb0ywmfMdfYyUmAJ2yPiBx6Wr/oy2Oqw\n+A1SupBzAOuE/AAAAABJRU5ErkJggg==\n"
  }, t.Grid = l, l.prototype = Object.create(O.prototype), l.prototype.constructor = l, l.prototype.requiredProps = [ "xy" ], l.prototype.defaultProps = {
    color: "gray",
    dasharray: "2,2",
    alpha: "0.5",
    nticks: 10,
    gridOn: !0,
    tickvalues: null,
    zorder: 0
  }, l.prototype.draw = function() {
    this.grid = e.svg.axis().scale(this.scale).orient(this.position).ticks(this.props.nticks).tickValues(this.props.tickvalues).tickSize(this.tickSize, 0, 0).tickFormat(""), this.elem = this.ax.axes.append("g").attr("class", this.cssclass).attr("transform", this.transform).call(this.grid), t.insert_css("div#" + this.ax.fig.figid + " ." + this.cssclass + " .tick", {
      stroke: this.props.color,
      "stroke-dasharray": this.props.dasharray,
      "stroke-opacity": this.props.alpha
    }), t.insert_css("div#" + this.ax.fig.figid + " ." + this.cssclass + " path", {
      "stroke-width": 0
    });
  }, l.prototype.zoomed = function() {
    this.elem.call(this.grid);
  }, t.Axis = c, c.prototype = Object.create(O.prototype), c.prototype.constructor = c, c.prototype.requiredProps = [ "position" ], c.prototype.defaultProps = {
    nticks: 10,
    tickvalues: null,
    tickformat: null,
    fontsize: "11px",
    fontcolor: "black",
    axiscolor: "black",
    scale: "linear",
    grid: {},
    zorder: 0
  }, c.prototype.getGrid = function() {
    var e = {
      nticks: this.props.nticks,
      zorder: this.props.zorder,
      tickvalues: this.props.tickvalues,
      xy: this.props.xy
    };
    if (this.props.grid) for (var t in this.props.grid) e[t] = this.props.grid[t];
    return new l(this.ax, e);
  }, c.prototype.draw = function() {
    this.props.tickvalues ? tick_labels = e.scale.threshold().domain(this.props.tickvalues.slice(1)).range(this.props.tickformat) : tick_labels = null, this.axis = e.svg.axis().scale(this.scale).orient(this.props.position).ticks(this.props.nticks).tickValues(this.props.tickvalues).tickFormat(tick_labels), this.elem = this.ax.baseaxes.append("g").attr("transform", this.transform).attr("class", this.cssclass).call(this.axis), t.insert_css("div#" + this.ax.fig.figid + " ." + this.cssclass + " line, " + " ." + this.cssclass + " path", {
      "shape-rendering": "crispEdges",
      stroke: this.props.axiscolor,
      fill: "none"
    }), t.insert_css("div#" + this.ax.fig.figid + " ." + this.cssclass + " text", {
      "font-family": "sans-serif",
      "font-size": this.props.fontsize,
      fill: this.props.fontcolor,
      stroke: "none"
    });
  }, c.prototype.zoomed = function() {
    if (this.props.tickvalues != null) {
      var e = this.axis.scale().domain();
      this.axis.tickValues(this.props.tickvalues.filter(function(t) {
        return t >= e[0] && t <= e[1];
      }));
    }
    this.elem.call(this.axis);
  }, t.Coordinates = h, h.prototype.xy = function(e, t, n) {
    return t = typeof t == "undefined" ? 0 : t, n = typeof n == "undefined" ? 1 : n, [ this.x(e[t]), this.y(e[n]) ];
  }, h.prototype.x_data = function(e) {
    return this.ax.x(e);
  }, h.prototype.y_data = function(e) {
    return this.ax.y(e);
  }, h.prototype.x_display = function(e) {
    return e;
  }, h.prototype.y_display = function(e) {
    return e;
  }, h.prototype.x_axes = function(e) {
    return e * this.ax.width;
  }, h.prototype.y_axes = function(e) {
    return this.ax.height * (1 - e);
  }, h.prototype.x_figure = function(e) {
    return e * this.fig.width - this.ax.position[0];
  }, h.prototype.y_figure = function(e) {
    return (1 - e) * this.fig.height - this.ax.position[1];
  }, t.Path = p, p.prototype = Object.create(O.prototype), p.prototype.constructor = p, p.prototype.requiredProps = [ "data" ], p.prototype.defaultProps = {
    xindex: 0,
    yindex: 1,
    coordinates: "data",
    facecolor: "green",
    edgecolor: "black",
    edgewidth: 1,
    dasharray: "none",
    pathcodes: null,
    offset: null,
    offsetcoordinates: "data",
    alpha: 1,
    zorder: 1
  }, p.prototype.nanFilter = function(e, t) {
    return !isNaN(e[this.props.xindex]) && !isNaN(e[this.props.yindex]);
  }, p.prototype.draw = function() {
    this.datafunc.defined(this.nanFilter.bind(this)).x(function(e) {
      return this.pathcoords.x(e[this.props.xindex]);
    }).y(function(e) {
      return this.pathcoords.y(e[this.props.yindex]);
    }), this.path = this.ax.axes.append("svg:path").attr("d", this.datafunc(this.data, this.pathcodes)).attr("class", "mpld3-path").style("stroke", this.props.edgecolor).style("stroke-width", this.props.edgewidth).style("stroke-dasharray", this.props.dasharray).style("stroke-opacity", this.props.alpha).style("fill", this.props.facecolor).style("fill-opacity", this.props.alpha).attr("vector-effect", "non-scaling-stroke");
    if (this.props.offset !== null) {
      var e = this.offsetcoords.xy(this.props.offset);
      this.path.attr("transform", "translate(" + e + ")");
    }
  }, p.prototype.elements = function(e) {
    return this.path;
  }, p.prototype.zoomed = function() {
    this.pathcoords.zoomable && this.path.attr("d", this.datafunc(this.data, this.pathcodes));
    if (this.props.offset !== null && this.offsetcoords.zoomable) {
      var e = this.offsetcoords.xy(this.props.offset);
      this.path.attr("transform", "translate(" + e + ")");
    }
  }, t.PathCollection = d, d.prototype = Object.create(O.prototype), d.prototype.constructor = d, d.prototype.requiredProps = [ "paths", "offsets" ], d.prototype.defaultProps = {
    xindex: 0,
    yindex: 1,
    pathtransforms: [],
    pathcoordinates: "display",
    offsetcoordinates: "data",
    offsetorder: "before",
    edgecolors: [ "#000000" ],
    edgewidths: [ 1 ],
    facecolors: [ "#0000FF" ],
    alphas: [ 1 ],
    zorder: 2
  }, d.prototype.transformFunc = function(t, n) {
    var r = this.props.pathtransforms, i = r.length == 0 ? "" : e.transform("matrix(" + u(r, n) + ")").toString(), s = t === null || typeof t == "undefined" ? "translate(0, 0)" : "translate(" + this.offsetcoords.xy(t, this.props.xindex, this.props.yindex) + ")";
    return this.props.offsetorder === "after" ? i + s : s + i;
  }, d.prototype.pathFunc = function(e, t) {
    return a().x(function(e) {
      return this.pathcoords.x(e[0]);
    }.bind(this)).y(function(e) {
      return this.pathcoords.y(e[1]);
    }.bind(this)).apply(this, u(this.props.paths, t));
  }, d.prototype.styleFunc = function(e, t) {
    var n = {
      stroke: u(this.props.edgecolors, t),
      "stroke-width": u(this.props.edgewidths, t),
      "stroke-opacity": u(this.props.alphas, t),
      fill: u(this.props.facecolors, t),
      "fill-opacity": u(this.props.alphas, t)
    }, r = "";
    for (var i in n) r += i + ":" + n[i] + ";";
    return r;
  }, d.prototype.draw = function() {
    this.group = this.ax.axes.append("svg:g"), this.pathsobj = this.group.selectAll("paths").data(this.offsets).enter().append("svg:path").attr("d", this.pathFunc.bind(this)).attr("class", "mpld3-path").attr("transform", this.transformFunc.bind(this)).attr("style", this.styleFunc.bind(this)).attr("vector-effect", "non-scaling-stroke");
  }, d.prototype.elements = function(e) {
    return this.group.selectAll("path");
  }, d.prototype.zoomed = function() {
    this.props.pathcoordinates === "data" && this.pathsobj.attr("d", this.pathFunc.bind(this)), this.props.offsetcoordinates === "data" && this.pathsobj.attr("transform", this.transformFunc.bind(this));
  }, t.Line = v, v.prototype = Object.create(p.prototype), v.prototype.constructor = v, v.prototype.requiredProps = [ "data" ], v.prototype.defaultProps = {
    xindex: 0,
    yindex: 1,
    coordinates: "data",
    color: "salmon",
    linewidth: 2,
    dasharray: "none",
    alpha: 1,
    zorder: 2
  }, t.Markers = m, m.prototype = Object.create(d.prototype), m.prototype.constructor = m, m.prototype.requiredProps = [ "data" ], m.prototype.defaultProps = {
    xindex: 0,
    yindex: 1,
    coordinates: "data",
    facecolor: "salmon",
    edgecolor: "black",
    edgewidth: 1,
    alpha: 1,
    markersize: 6,
    markername: "circle",
    markerpath: null,
    zorder: 3
  }, m.prototype.pathFunc = function(e, t) {
    return this.marker;
  }, t.Image = g, g.prototype = Object.create(O.prototype), g.prototype.constructor = g, g.prototype.requiredProps = [ "data", "extent" ], g.prototype.defaultProps = {
    alpha: 1,
    coordinates: "data",
    zorder: 1
  }, g.prototype.draw = function() {
    this.image = this.ax.axes.append("svg:image").attr("class", "mpld3-image").attr("xlink:href", "data:image/png;base64," + this.props.data).style({
      opacity: this.props.alpha
    }).attr("preserveAspectRatio", "none"), this.zoomed();
  }, g.prototype.elements = function(t) {
    return e.select(this.image);
  }, g.prototype.zoomed = function() {
    var e = this.props.extent;
    this.image.attr("x", this.coords.x(e[0])).attr("y", this.coords.y(e[3])).attr("width", this.coords.x(e[1]) - this.coords.x(e[0])).attr("height", this.coords.y(e[2]) - this.coords.y(e[3]));
  }, t.Text = y, y.prototype = Object.create(O.prototype), y.prototype.constructor = y, y.prototype.requiredProps = [ "text", "position" ], y.prototype.defaultProps = {
    coordinates: "data",
    h_anchor: "start",
    v_baseline: "auto",
    rotation: 0,
    fontsize: 11,
    color: "black",
    alpha: 1,
    zorder: 3
  }, y.prototype.draw = function() {
    this.props.coordinates == "data" ? this.obj = this.ax.axes.append("text") : this.obj = this.ax.baseaxes.append("text"), this.obj.attr("class", "mpld3-text").text(this.text).style("text-anchor", this.props.h_anchor).style("dominant-baseline", this.props.v_baseline).style("font-size", this.props.fontsize).style("fill", this.props.color).style("opacity", this.props.alpha), this.applyTransform();
  }, y.prototype.elements = function(t) {
    return e.select(this.obj);
  }, y.prototype.applyTransform = function() {
    var e = this.coords.xy(this.position);
    this.obj.attr("x", e[0]).attr("y", e[1]), this.props.rotation && this.obj.attr("transform", "rotate(" + this.props.rotation + "," + e + ")");
  }, y.prototype.zoomed = function() {
    this.coords.zoomable && this.applyTransform();
  }, t.Axes = b, b.prototype = Object.create(O.prototype), b.prototype.constructor = b, b.prototype.requiredProps = [ "xlim", "ylim" ], b.prototype.defaultProps = {
    bbox: [ .1, .1, .8, .8 ],
    axesbg: "#FFFFFF",
    axesbgalpha: 1,
    gridOn: !1,
    xdomain: null,
    ydomain: null,
    xscale: "linear",
    yscale: "linear",
    zoomable: !0,
    axes: [ {
      position: "left"
    }, {
      position: "bottom"
    } ],
    lines: [],
    paths: [],
    markers: [],
    texts: [],
    collections: [],
    sharex: [],
    sharey: [],
    images: []
  }, b.prototype.draw = function() {
    for (var n = 0; n < this.props.sharex.length; n++) this.sharex.push(t.get_element(this.props.sharex[n]));
    for (var n = 0; n < this.props.sharey.length; n++) this.sharey.push(t.get_element(this.props.sharey[n]));
    this.zoom = e.behavior.zoom(), this.zoom.last_t = this.zoom.translate(), this.zoom.last_s = this.zoom.scale(), this.zoom_x = e.behavior.zoom().x(this.xdom), this.zoom_y = e.behavior.zoom().y(this.ydom), this.baseaxes = this.fig.canvas.append("g").attr("transform", "translate(" + this.position[0] + "," + this.position[1] + ")").attr("width", this.width).attr("height", this.height).attr("class", "mpld3-baseaxes"), this.clip = this.baseaxes.append("svg:clipPath").attr("id", this.clipid).append("svg:rect").attr("x", 0).attr("y", 0).attr("width", this.width).attr("height", this.height), this.axes = this.baseaxes.append("g").attr("class", "mpld3-axes").attr("clip-path", "url(#" + this.clipid + ")"), this.axesbg = this.axes.append("svg:rect").attr("width", this.width).attr("height", this.height).attr("class", "mpld3-axesbg").style("fill", this.props.axesbg).style("fill-opacity", this.props.axesbgalpha);
    for (var n = 0; n < this.elements.length; n++) this.elements[n].draw();
  }, b.prototype.enable_zoom = function() {
    this.props.zoomable && (this.zoom.on("zoom", this.zoomed.bind(this, !0)), this.axes.call(this.zoom), this.axes.style("cursor", "move"));
  }, b.prototype.disable_zoom = function() {
    this.props.zoomable && (this.zoom.on("zoom", null), this.axes.on(".zoom", null), this.axes.style("cursor", null));
  }, b.prototype.zoomed = function(e) {
    e = typeof e == "undefined" ? !0 : e;
    if (e) {
      var t = this.zoom.translate()[0] - this.zoom.last_t[0], n = this.zoom.translate()[1] - this.zoom.last_t[1], r = this.zoom.scale() / this.zoom.last_s;
      this.zoom_x.translate([ this.zoom_x.translate()[0] + t, 0 ]), this.zoom_x.scale(this.zoom_x.scale() * r), this.zoom_y.translate([ 0, this.zoom_y.translate()[1] + n ]), this.zoom_y.scale(this.zoom_y.scale() * r), this.zoom.last_t = this.zoom.translate(), this.zoom.last_s = this.zoom.scale(), this.sharex.forEach(function(e) {
        e.zoom_x.translate(this.zoom_x.translate()).scale(this.zoom_x.scale());
      }.bind(this)), this.sharey.forEach(function(e) {
        e.zoom_y.translate(this.zoom_y.translate()).scale(this.zoom_y.scale());
      }.bind(this)), this.sharex.forEach(function(e) {
        e.zoomed(!1);
      }), this.sharey.forEach(function(e) {
        e.zoomed(!1);
      });
    }
    for (var i = 0; i < this.elements.length; i++) this.elements[i].zoomed();
  }, b.prototype.reset = function(e, t) {
    this.set_axlim(this.props.xdomain, this.props.ydomain, e, t);
  }, b.prototype.set_axlim = function(n, r, i, u) {
    n = o(n) ? this.xdom.domain() : n, r = o(r) ? this.ydom.domain() : r, i = o(i) ? 750 : i, u = s(u) ? !0 : u;
    var a = this.props.xscale === "date" ? t.interpolateDates(this.xdom.domain(), n) : e.interpolate(this.xdom.domain(), n), f = this.props.yscale === "date" ? t.interpolateDates(this.ydom.domain(), r) : e.interpolate(this.ydom.domain(), r), l = function(e) {
      this.zoom_x.x(this.xdom.domain(a(e))), this.zoom_y.y(this.ydom.domain(f(e))), this.zoomed(!1);
    }.bind(this);
    e.select({}).transition().duration(i).tween("zoom", function() {
      return l;
    }), u && (this.sharex.forEach(function(e) {
      e.set_axlim(n, null, i, !1);
    }), this.sharey.forEach(function(e) {
      e.set_axlim(null, r, i, !1);
    })), this.zoom.scale(1).translate([ 0, 0 ]), this.zoom.last_t = this.zoom.translate(), this.zoom.last_s = this.zoom.scale(), this.zoom_x.scale(1).translate([ 0, 0 ]), this.zoom_y.scale(1).translate([ 0, 0 ]);
  }, t.Toolbar = w, w.prototype = Object.create(O.prototype), w.prototype.constructor = w, w.prototype.defaultProps = {
    buttons: [ "reset", "move" ]
  }, w.prototype.addButton = function(e) {
    this.buttons.push(new e(this));
  }, w.prototype.draw = function() {
    function n() {
      this.buttonsobj.transition(750).attr("y", 0);
    }
    function r() {
      this.buttonsobj.transition(750).delay(250).attr("y", 16);
    }
    t.insert_css("div#" + this.fig.figid + " .mpld3-toolbar image", {
      cursor: "pointer",
      opacity: .2,
      display: "inline-block",
      margin: "0px"
    }), t.insert_css("div#" + this.fig.figid + " .mpld3-toolbar image.active", {
      opacity: .4
    }), t.insert_css("div#" + this.fig.figid + " .mpld3-toolbar image.pressed", {
      opacity: .6
    }), this.fig.canvas.on("mouseenter", n.bind(this)).on("mouseleave", r.bind(this)).on("touchenter", n.bind(this)).on("touchstart", n.bind(this)), this.toolbar = this.fig.canvas.append("svg:svg").attr("width", 16 * this.buttons.length).attr("height", 16).attr("x", 2).attr("y", this.fig.height - 16 - 2).attr("class", "mpld3-toolbar"), this.buttonsobj = this.toolbar.append("svg:g").selectAll("buttons").data(this.buttons).enter().append("svg:image").attr("class", function(e) {
      return e.cssclass;
    }).attr("xlink:href", function(e) {
      return e.icon();
    }).attr("width", 16).attr("height", 16).attr("x", function(e, t) {
      return t * 16;
    }).attr("y", 16).on("click", function(e) {
      e.click();
    }).on("mouseenter", function() {
      e.select(this).classed({
        active: 1
      });
    }).on("mouseleave", function() {
      e.select(this).classed({
        active: 0
      });
    });
    for (var i = 0; i < this.buttons.length; i++) this.buttons[i].onDraw();
  }, w.prototype.deactivate_all = function() {
    this.buttons.forEach(function(e) {
      e.deactivate();
    });
  }, w.prototype.deactivate_by_action = function(e) {
    function t(t) {
      return e.indexOf(t) !== -1;
    }
    e.length > 0 && this.buttons.forEach(function(e) {
      e.actions.filter(t).length > 0 && e.deactivate();
    });
  }, t.Button = E, E.prototype = Object.create(O.prototype), E.prototype.constructor = E, E.prototype.setState = function(e) {
    e ? this.activate() : this.deactivate();
  }, E.prototype.click = function() {
    this.active ? this.deactivate() : this.activate();
  }, E.prototype.activate = function() {
    this.toolbar.deactivate_by_action(this.actions), this.onActivate(), this.active = !0, this.toolbar.toolbar.select("." + this.cssclass).classed({
      pressed: !0
    }), this.sticky || this.deactivate();
  }, E.prototype.deactivate = function() {
    this.onDeactivate(), this.active = !1, this.toolbar.toolbar.select("." + this.cssclass).classed({
      pressed: !1
    });
  }, E.prototype.sticky = !1, E.prototype.actions = [], E.prototype.icon = function() {
    return "";
  }, E.prototype.onActivate = function() {}, E.prototype.onDeactivate = function() {}, E.prototype.onDraw = function() {}, t.ButtonFactory = function(e) {
    function t(e) {
      E.call(this, e, this.buttonID);
    }
    if (typeof e.buttonID != "string") throw "ButtonFactory: buttonID must be present and be a string";
    t.prototype = Object.create(E.prototype), t.prototype.constructor = t;
    for (var n in e) t.prototype[n] = e[n];
    return t;
  }, t.Plugin = S, S.prototype = Object.create(O.prototype), S.prototype.constructor = S, S.prototype.requiredProps = [], S.prototype.defaultProps = {}, S.prototype.draw = function() {}, t.ResetPlugin = x, t.register_plugin("reset", x), x.prototype = Object.create(S.prototype), x.prototype.constructor = x, x.prototype.requiredProps = [], x.prototype.defaultProps = {}, t.ZoomPlugin = T, t.register_plugin("zoom", T), T.prototype = Object.create(S.prototype), T.prototype.constructor = T, T.prototype.requiredProps = [], T.prototype.defaultProps = {
    button: !0,
    enabled: null
  }, T.prototype.activate = function() {
    this.fig.enable_zoom();
  }, T.prototype.deactivate = function() {
    this.fig.disable_zoom();
  }, T.prototype.draw = function() {
    this.props.enabled ? this.fig.enable_zoom() : this.fig.disable_zoom();
  }, t.BoxZoomPlugin = N, t.register_plugin("boxzoom", N), N.prototype = Object.create(S.prototype), N.prototype.constructor = N, N.prototype.requiredProps = [], N.prototype.defaultProps = {
    button: !0,
    enabled: null
  }, N.prototype.activate = function() {
    this.enable && this.enable();
  }, N.prototype.deactivate = function() {
    this.disable && this.disable();
  }, N.prototype.draw = function() {
    function n(t) {
      if (this.enabled) {
        var n = e.extent();
        e.empty() || t.set_axlim([ n[0][0], n[1][0] ], [ n[0][1], n[1][1] ]);
      }
      t.axes.call(e.clear());
    }
    t.insert_css("#" + this.fig.figid + " rect.extent." + this.extentClass, {
      fill: "#fff",
      "fill-opacity": 0,
      stroke: "#999"
    });
    var e = this.fig.getBrush();
    this.enable = function() {
      this.fig.showBrush(this.extentClass), e.on("brushend", n.bind(this)), this.enabled = !0;
    }, this.disable = function() {
      this.fig.hideBrush(this.extentClass), this.enabled = !1;
    }, this.toggle = function() {
      this.enabled ? this.disable() : this.enable();
    }, this.disable();
  }, t.TooltipPlugin = C, t.register_plugin("tooltip", C), C.prototype = Object.create(S.prototype), C.prototype.constructor = C, C.prototype.requiredProps = [ "id" ], C.prototype.defaultProps = {
    labels: null,
    hoffset: 0,
    voffset: 10,
    location: "mouse"
  }, C.prototype.draw = function() {
    function s(e, t) {
      this.tooltip.style("visibility", "visible").text(r === null ? "(" + e + ")" : u(r, t));
    }
    function o(t, n) {
      if (i === "mouse") {
        var r = e.mouse(this.fig.canvas.node());
        this.x = r[0] + this.props.hoffset, this.y = r[1] - this.props.voffset;
      }
      this.tooltip.attr("x", this.x).attr("y", this.y);
    }
    function a(e, t) {
      this.tooltip.style("visibility", "hidden");
    }
    var n = t.get_element(this.props.id, this.fig), r = this.props.labels, i = this.props.location;
    this.tooltip = this.fig.canvas.append("text").attr("class", "mpld3-tooltip-text").attr("x", 0).attr("y", 0).text("").style("visibility", "hidden"), i == "bottom left" || i == "top left" ? (this.x = n.ax.position[0] + 5 + this.props.hoffset, this.tooltip.style("text-anchor", "beginning")) : i == "bottom right" || i == "top right" ? (this.x = n.ax.position[0] + n.ax.width - 5 + this.props.hoffset, this.tooltip.style("text-anchor", "end")) : this.tooltip.style("text-anchor", "middle");
    if (i == "bottom left" || i == "bottom right") this.y = n.ax.position[1] + n.ax.height - 5 + this.props.voffset; else if (i == "top left" || i == "top right") this.y = n.ax.position[1] + 5 + this.props.voffset;
    n.elements().on("mouseover", s.bind(this)).on("mousemove", o.bind(this)).on("mouseout", a.bind(this));
  }, t.LinkedBrushPlugin = k, t.register_plugin("linkedbrush", k), k.prototype = Object.create(t.Plugin.prototype), k.prototype.constructor = k, k.prototype.requiredProps = [ "id" ], k.prototype.defaultProps = {
    button: !0,
    enabled: null
  }, k.prototype.activate = function() {
    this.enable && this.enable();
  }, k.prototype.deactivate = function() {
    this.disable && this.disable();
  }, k.prototype.draw = function() {
    function c(t) {
      l != this && (e.select(l).call(o.clear()), l = this, o.x(t.xdom).y(t.ydom));
    }
    function h(e) {
      var t = u[e.axnum];
      if (t.length > 0) {
        var n = t[0].props.xindex, r = t[0].props.yindex, i = o.extent();
        o.empty() ? f.selectAll("path").classed("mpld3-hidden", !1) : f.selectAll("path").classed("mpld3-hidden", function(e) {
          return i[0][0] > e[n] || i[1][0] < e[n] || i[0][1] > e[r] || i[1][1] < e[r];
        });
      }
    }
    function p(e) {
      o.empty() && f.selectAll("path").classed("mpld3-hidden", !1);
    }
    var n = t.get_element(this.props.id);
    if (n === null) throw "LinkedBrush: no object with id='" + this.props.id + "' was found";
    var r = this.fig;
    if (!("offsets" in n.props)) throw "Plot object with id='" + this.props.id + "' is not a scatter plot";
    var i = "offsets" in n.props ? "offsets" : "data";
    t.insert_css("#" + r.figid + " rect.extent." + this.extentClass, {
      fill: "#000",
      "fill-opacity": .125,
      stroke: "#fff"
    }), t.insert_css("#" + r.figid + " path.mpld3-hidden", {
      stroke: "#ccc !important",
      fill: "#ccc !important"
    });
    var s = "mpld3data-" + n.props[i], o = r.getBrush(), u = [];
    r.axes.forEach(function(e) {
      var t = [];
      e.elements.forEach(function(e) {
        e.props[i] === n.props[i] && (e.group.classed(s, !0), t.push(e));
      }), u.push(t);
    });
    var a = [], f = r.canvas.selectAll("." + s), l;
    this.enable = function() {
      this.fig.showBrush(this.extentClass), o.on("brushstart", c).on("brush", h).on("brushend", p), this.enabled = !0;
    }, this.disable = function() {
      e.select(l).call(o.clear()), this.fig.hideBrush(this.extentClass), this.enabled = !1;
    }, this.disable();
  }, t.register_plugin("mouseposition", L), L.prototype = Object.create(t.Plugin.prototype), L.prototype.constructor = L, L.prototype.requiredProps = [], L.prototype.defaultProps = {
    fontsize: 12,
    fmt: ".3g"
  }, L.prototype.draw = function() {
    var t = this.fig, n = e.format(this.props.fmt), r = t.canvas.append("text").attr("class", "mpld3-coordinates").style("text-anchor", "end").style("font-size", this.props.fontsize).attr("x", this.fig.width - 5).attr("y", this.fig.height - 5);
    for (var i = 0; i < this.fig.axes.length; i++) {
      var s = function() {
        var s = t.axes[i];
        return function() {
          var t = e.mouse(this), i = s.x.invert(t[0]), o = s.y.invert(t[1]);
          r.text("(" + n(i) + ", " + n(o) + ")");
        };
      }();
      t.axes[i].baseaxes.on("mousemove", s).on("mouseout", function() {
        r.text("");
      });
    }
  }, t.Figure = A, A.prototype = Object.create(O.prototype), A.prototype.constructor = A, A.prototype.requiredProps = [ "width", "height" ], A.prototype.defaultProps = {
    data: {},
    axes: [],
    plugins: [ {
      type: "reset"
    }, {
      type: "zoom"
    }, {
      type: "boxzoom"
    } ]
  }, A.prototype.getBrush = function() {
    if (typeof this._brush == "undefined") {
      var t = e.svg.brush().x(e.scale.linear()).y(e.scale.linear());
      this.root.selectAll(".mpld3-axes").data(this.axes).call(t), this.axes.forEach(function(e) {
        t.x(e.xdom).y(e.ydom), e.axes.call(t);
      }), this._brush = t, this.hideBrush();
    }
    return this._brush;
  }, A.prototype.showBrush = function(e) {
    e = typeof e == "undefined" ? "" : e;
    var t = this.getBrush();
    t.on("brushstart", function(e) {
      t.x(e.xdom).y(e.ydom);
    }), this.canvas.selectAll("rect.background").style("cursor", "crosshair").style("pointer-events", null), this.canvas.selectAll("rect.extent, rect.resize").style("display", null).classed(e, !0);
  }, A.prototype.hideBrush = function(e) {
    e = typeof e == "undefined" ? "" : e;
    var t = this.getBrush();
    t.on("brushstart", null).on("brush", null).on("brushend", function(e) {
      e.axes.call(t.clear());
    }), this.canvas.selectAll("rect.background").style("cursor", null).style("pointer-events", "visible"), this.canvas.selectAll("rect.extent, rect.resize").style("display", "none").classed(e, !1);
  }, A.prototype.add_plugin = function(e) {
    var r = e.type;
    if (typeof r == "undefined") {
      console.warn("unspecified plugin type. Skipping this");
      return;
    }
    e = n(e), delete e.type, r in t.plugin_map && (r = t.plugin_map[r]);
    if (typeof r != "function") {
      console.warn("Skipping unrecognized plugin: " + r);
      return;
    }
    e.clear_toolbar && (this.props.toolbar = []);
    if ("buttons" in e) if (typeof e.buttons == "string") this.props.toolbar.push(e.buttons); else for (var i = 0; i < e.buttons.length; i++) this.props.toolbar.push(e.buttons[i]);
    this.plugins.push(new r(this, e));
  }, A.prototype.draw = function() {
    this.canvas = this.root.append("svg:svg").attr("class", "mpld3-figure").attr("width", this.width).attr("height", this.height);
    for (var e = 0; e < this.axes.length; e++) this.axes[e].draw();
    this.disable_zoom();
    for (var e = 0; e < this.plugins.length; e++) this.plugins[e].draw();
    this.toolbar.draw();
  }, A.prototype.reset = function(e) {
    this.axes.forEach(function(t) {
      t.reset(e, !1);
    });
  }, A.prototype.enable_zoom = function() {
    for (var e = 0; e < this.axes.length; e++) this.axes[e].enable_zoom();
    this.zoom_on = !0;
  }, A.prototype.disable_zoom = function() {
    for (var e = 0; e < this.axes.length; e++) this.axes[e].disable_zoom();
    this.zoom_on = !1;
  }, A.prototype.toggle_zoom = function() {
    this.zoom_on ? this.disable_zoom() : this.enable_zoom();
  }, A.prototype.get_data = function(e) {
    return e === null || typeof e == "undefined" ? null : typeof e == "string" ? this.data[e] : e;
  }, t.PlotElement = O, O.prototype.requiredProps = [], O.prototype.defaultProps = {}, O.prototype.processProps = function(e) {
    e = n(e);
    var r = {}, i = this.name();
    this.requiredProps.forEach(function(t) {
      if (!(t in e)) throw "property '" + t + "' " + "must be specified for " + i;
      r[t] = e[t], delete e[t];
    });
    for (var s in this.defaultProps) s in e ? (r[s] = e[s], delete e[s]) : r[s] = this.defaultProps[s];
    "id" in e ? (r.id = e.id, delete e.id) : "id" in r || (r.id = t.generateId());
    for (var s in e) console.warn("Unrecognized property '" + s + "' " + "for object " + this.name() + " (value = " + e[s] + ").");
    return r;
  }, O.prototype.name = function() {
    var e = /function (.{1,})\(/, t = e.exec(this.constructor.toString());
    return t && t.length > 1 ? t[1] : "";
  }, typeof module == "object" && module.exports ? module.exports = t : this.mpld3 = t, console.log("Loaded mpld3 version " + t.version);
}(d3);