/* mpld3.js: javascript backend for displaying interactive matplotlib plots *//*   Author: Jake Vanderplas                                                *//*   License: 3-clause BSD (see http://github.com/jakevdp/mpld3)            *//*                                                                          *//* Notes:                                                                   *//* - the objects here use prototype-based definitions rather than           *//*   closure-based definitions for the sake of memory efficiency.           *//*                                                                          *//* - this assumes that d3 is defined in the global namespace, and the       *//*   result is that mpld3 is defined in the global namespace.               *//*                                                                          */!function(e){function t(e){var t={};for(var n in e)t[n]=e[n];return t}function n(e,t){e=typeof e!="undefined"?e:10,t=typeof t!="undefined"?t:"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";var n=t.charAt(Math.round(Math.random()*(t.length-11)));for(var r=1;r<e;r++)n+=t.charAt(Math.round(Math.random()*(t.length-1)));return n}function r(t,n){var r=e.interpolate([t[0].valueOf(),t[1].valueOf()],[n[0].valueOf(),n[1].valueOf()]);return function(e){var t=r(e);return[new Date(t[0]),new Date(t[1])]}}function i(e){return typeof e=="undefined"}function s(e){return e==null||i(e)}function o(e,t){return e.length>0?e[t%e.length]:null}function u(t){function n(t,n){var u=e.functor(r),a=e.functor(i),f=[],l=[],c=0,h=-1,p=0,d=!1;if(!n){n=["M"];for(var v=1;v<t.length;v++)n.push("L")}while(++h<n.length){p=c+o[n[h]],f=[];while(c<p)s.call(this,t[c],c)?(f.push(u.call(this,t[c],c),a.call(this,t[c],c)),c++):(f=null,c=p);f?d&&f.length>0?(l.push("M",f[0],f[1]),d=!1):(l.push(n[h]),l=l.concat(f)):d=!0}return c!=t.length&&console.warn("Warning: not all vertices used in Path"),l.join(" ")}var r=function(e,t){return e[0]},i=function(e,t){return e[1]},s=function(e,t){return!0},o={M:1,m:1,L:1,l:1,Q:2,q:2,T:1,t:1,S:2,s:2,C:3,c:3,Z:0,z:0};return n.x=function(e){return arguments.length?(r=e,n):r},n.y=function(e){return arguments.length?(i=e,n):i},n.defined=function(e){return arguments.length?(s=e,n):s},n.call=n,n}function a(e){function t(e){return n.forEach(function(t){e=t(e)}),e}var n=Array.prototype.slice.call(arguments,0),r=n.length;return t.domain=function(e){return arguments.length?(n[0].domain(e),t):n[0].domain()},t.range=function(e){return arguments.length?(n[r-1].range(e),t):n[r-1].range()},t.step=function(e){return n[e]},t}function f(e,t){A.call(this,e,t),this.cssclass="mpld3-"+this.props.xy+"grid";if(this.props.xy=="x")this.transform="translate(0,"+this.ax.height+")",this.position="bottom",this.scale=this.ax.xdom,this.tickSize=-this.ax.height;else{if(this.props.xy!="y")throw"unrecognized grid xy specifier: should be 'x' or 'y'";this.transform="translate(0,0)",this.position="left",this.scale=this.ax.ydom,this.tickSize=-this.ax.width}}function l(e,t){A.call(this,e,t);var n={bottom:[0,this.ax.height],top:[0,0],left:[0,0],right:[this.ax.width,0]},r={bottom:"x",top:"x",left:"y",right:"y"};this.transform="translate("+n[this.props.position]+")",this.props.xy=r[this.props.position],this.cssclass="mpld3-"+this.props.xy+"axis",this.scale=this.ax[this.props.xy+"dom"]}function c(e,t){if(typeof t=="undefined"){this.ax=null,this.fig=null;if(this.trans!=="display")throw"ax must be defined if transform != 'display'"}else this.ax=t,this.fig=t.fig;this.zoomable=e==="data",this.x=this["x_"+e],this.y=this["y_"+e];if(typeof this.x=="undefined"||typeof this.y=="undefined")throw"unrecognized coordinate code: "+e}function h(e,t){A.call(this,e,t),this.data=e.fig.get_data(this.props.data),this.pathcodes=this.props.pathcodes,this.pathcoords=new c(this.props.coordinates,this.ax),this.offsetcoords=new c(this.props.offsetcoordinates,this.ax),this.datafunc=u()}function p(e,t){A.call(this,e,t);if(this.props.facecolors==null||this.props.facecolors.length==0)this.props.facecolors=["none"];if(this.props.edgecolors==null||this.props.edgecolors.length==0)this.props.edgecolors=["none"];var n=this.ax.fig.get_data(this.props.offsets);if(n===null||n.length===0)n=[null];var r=Math.max(this.props.paths.length,n.length);if(n.length===r)this.offsets=n;else{this.offsets=[];for(var i=0;i<r;i++)this.offsets.push(o(n,i))}this.pathcoords=new c(this.props.pathcoordinates,this.ax),this.offsetcoords=new c(this.props.offsetcoordinates,this.ax)}function d(t,n){A.call(this,t,n);var r=this.props;r.facecolor="none",r.edgecolor=r.color,delete r.color,r.edgewidth=r.linewidth,delete r.linewidth,this.defaultProps=h.prototype.defaultProps,h.call(this,t,r),this.datafunc=e.svg.line().interpolate("linear")}function v(t,n){A.call(this,t,n),this.props.markerpath!==null?this.marker=this.props.markerpath[0].length==0?null:O.path().call(this.props.markerpath[0],this.props.markerpath[1]):this.marker=this.props.markername===null?null:e.svg.symbol(this.props.markername).size(Math.pow(this.props.markersize,2))();var r={paths:[this.props.markerpath],offsets:t.fig.get_data(this.props.data),xindex:this.props.xindex,yindex:this.props.yindex,offsetcoordinates:this.props.coordinates,edgecolors:[this.props.edgecolor],edgewidths:[this.props.edgewidth],facecolors:[this.props.facecolor],alphas:[this.props.alpha],zorder:this.props.zorder,id:this.props.id};this.requiredProps=p.prototype.requiredProps,this.defaultProps=p.prototype.defaultProps,p.call(this,t,r)}function m(e,t){A.call(this,e,t),this.coords=new c(this.props.coordinates,this.ax)}function g(e,t){A.call(this,e,t),this.text=this.props.text,this.position=this.props.position,this.coords=new c(this.props.coordinates,this.ax)}function y(t,n){function r(e){return new Date(e[0],e[1],e[2],e[3],e[4],e[5])}function i(e,t){return e!=="date"?t:[r(t[0]),r(t[1])]}function s(t,n,r){var i=t==="date"?e.time.scale():t==="log"?e.scale.log():e.scale.linear();return i.domain(n).range(r)}A.call(this,t,n),this.axnum=this.fig.axes.length,this.axid=this.fig.figid+"_ax"+(this.axnum+1),this.clipid=this.axid+"_clip",this.props.xdomain=this.props.xdomain||this.props.xlim,this.props.ydomain=this.props.ydomain||this.props.ylim,this.sharex=[],this.sharey=[],this.elements=[];var o=this.props.bbox;this.position=[o[0]*this.fig.width,(1-o[1]-o[3])*this.fig.height],this.width=o[2]*this.fig.width,this.height=o[3]*this.fig.height,this.props.xdomain=i(this.props.xscale,this.props.xdomain),this.props.ydomain=i(this.props.yscale,this.props.ydomain),this.x=this.xdom=s(this.props.xscale,this.props.xdomain,[0,this.width]),this.y=this.ydom=s(this.props.yscale,this.props.ydomain,[this.height,0]),this.props.xscale==="date"&&(this.x=O.multiscale(e.scale.linear().domain(this.props.xlim).range(this.props.xdomain.map(Number)),this.xdom)),this.props.yscale==="date"&&(this.x=O.multiscale(e.scale.linear().domain(this.props.ylim).range(this.props.ydomain.map(Number)),this.ydom));var u=this.props.axes;for(var a=0;a<u.length;a++){var f=new O.Axis(this,u[a]);this.elements.push(f),(this.props.gridOn||f.props.grid.gridOn)&&this.elements.push(f.getGrid())}var l=this.props.paths;for(var a=0;a<l.length;a++)this.elements.push(new O.Path(this,l[a]));var c=this.props.lines;for(var a=0;a<c.length;a++)this.elements.push(new O.Line(this,c[a]));var h=this.props.markers;for(var a=0;a<h.length;a++)this.elements.push(new O.Markers(this,h[a]));var p=this.props.texts;for(var a=0;a<p.length;a++)this.elements.push(new O.Text(this,p[a]));var d=this.props.collections;for(var a=0;a<d.length;a++)this.elements.push(new O.PathCollection(this,d[a]));var v=this.props.images;for(var a=0;a<v.length;a++)this.elements.push(new O.Image(this,v[a]));this.elements.sort(function(e,t){return e.props.zorder-t.props.zorder})}function b(e,t){A.call(this,e,t),this.buttons=[],this.props.buttons.forEach(this.addButton.bind(this))}function w(e,t){A.call(this,e),this.toolbar=e,this.fig=this.toolbar.fig,this.cssclass="mpld3-"+t+"button",this.active=!1}function E(e,t){A.call(this,e,t)}function S(e,t){E.call(this,e,t);var n=O.ButtonFactory({buttonID:"reset",sticky:!1,onActivate:function(){this.toolbar.fig.reset()},icon:function(){return O.icons.reset}});this.fig.buttons.push(n)}function x(e,t){E.call(this,e,t),this.props.enabled===null&&(this.props.enabled=!this.props.button);var n=this.props.enabled;if(this.props.button){var r=O.ButtonFactory({buttonID:"zoom",sticky:!0,actions:["scroll","drag"],onActivate:this.activate.bind(this),onDeactivate:this.deactivate.bind(this),onDraw:function(){this.setState(n)},icon:function(){return O.icons.move}});this.fig.buttons.push(r)}}function T(e,t){E.call(this,e,t),this.props.enabled===null&&(this.props.enabled=!this.props.button);var n=this.props.enabled;if(this.props.button){var r=O.ButtonFactory({buttonID:"boxzoom",sticky:!0,actions:["drag"],onActivate:this.activate.bind(this),onDeactivate:this.deactivate.bind(this),onDraw:function(){this.setState(n)},icon:function(){return O.icons.zoom}});this.fig.buttons.push(r)}this.extentClass="boxzoombrush"}function N(e,t){E.call(this,e,t)}function C(e,t){O.Plugin.call(this,e,t),this.props.enabled===null&&(this.props.enabled=!this.props.button);var n=this.props.enabled;if(this.props.button){var r=O.ButtonFactory({buttonID:"linkedbrush",sticky:!0,actions:["drag"],onActivate:this.activate.bind(this),onDeactivate:this.deactivate.bind(this),onDraw:function(){this.setState(n)},icon:function(){return O.icons.brush}});this.fig.buttons.push(r)}this.extentClass="linkedbrush"}function k(e,t){O.Plugin.call(this,e,t)}function L(t,n){A.call(this,null,n),this.figid=t,this.width=this.props.width,this.height=this.props.height,this.data=this.props.data,this.buttons=[],this.root=e.select("#"+t).append("div").style("position","relative"),this.axes=[];for(var r=0;r<this.props.axes.length;r++)this.axes.push(new y(this,this.props.axes[r]));this.plugins=[];for(var r=0;r<this.props.plugins.length;r++)this.add_plugin(this.props.plugins[r]);this.toolbar=new O.Toolbar(this,{buttons:this.buttons})}function A(e,t){this.parent=s(e)?null:e,this.props=s(t)?{}:this.processProps(t),this.fig=e instanceof L?e:e&&"fig"in e?e.fig:null,this.ax=e instanceof y?e:e&&"ax"in e?e.ax:null}var O={_mpld3IsLoaded:!0,figures:[],plugin_map:{}};O.version="0.3git",O.register_plugin=function(e,t){O.plugin_map[e]=t},O.draw_figure=function(e,t){var n=document.getElementById(e);if(n===null)throw e+" is not a valid id";var r=new O.Figure(e,t);return O.figures.push(r),r.draw(),r},O.cloneObj=t,O.merge_objects=function(e){var t={},n;for(var r=0;r<arguments.length;r++){n=arguments[r];for(var i in n)t[i]=n[i]}return t},O.generate_id=function(e,t){return console.warn("mpld3.generate_id is deprecated. Use mpld3.generateId instead."),n(e,t)},O.generateId=n,O.get_element=function(e,t){var n,r,i;typeof t=="undefined"?n=O.figures:typeof t.length=="undefined"?n=[t]:n=t;for(var s=0;s<n.length;s++){t=n[s];if(t.props.id===e)return t;for(var o=0;o<t.axes.length;o++){r=t.axes[o];if(r.props.id===e)return r;for(var u=0;u<r.elements.length;u++){i=r.elements[u];if(i.props.id===e)return i}}}return null},O.insert_css=function(e,t){var n=document.head||document.getElementsByTagName("head")[0],r=document.createElement("style"),i=e+" {";for(var s in t)i+=s+":"+t[s]+"; ";i+="}",r.type="text/css",r.styleSheet?r.styleSheet.cssText=i:r.appendChild(document.createTextNode(i)),n.appendChild(r)},O.process_props=function(e,t,n,r){function i(e){A.call(this,null,e)}console.warn("mpld3.process_props is deprecated. Plot elements should derive from mpld3.PlotElement"),i.prototype=Object.create(A.prototype),i.prototype.constructor=i,i.prototype.requiredProps=r,i.prototype.defaultProps=n;var s=new i(t);return s.props},O.interpolateDates=r,O.path=function(){return u()},O.multiscale=a,O.icons={reset:"data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABmJLR0QA/wD/AP+gvaeTAAAACXBI\nWXMAAAsTAAALEwEAmpwYAAAAB3RJTUUH3gIcACMoD/OzIwAAAJhJREFUOMtjYKAx4KDUgNsMDAx7\nyNV8i4GB4T8U76VEM8mGYNNMtCH4NBM0hBjNMIwSsMzQ0MamcDkDA8NmQi6xggpUoikwQbIkHk2u\nE0rLI7vCBknBSyxeRDZAE6qHgQkq+ZeBgYERSfFPAoHNDNUDN4BswIRmKgxwEasP2dlsDAwMYlA/\n/mVgYHiBpkkGKscIDaPfVMmuAGnOTaGsXF0MAAAAAElFTkSuQmCC\n",move:"data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABmJLR0QA/wD/AP+gvaeTAAAACXBI\nWXMAAAsTAAALEwEAmpwYAAAAB3RJTUUH3gIcACQMfLHBNQAAANZJREFUOMud07FKA0EQBuAviaKB\nlFr7COJrpAyYRlKn8hECEkFEn8ROCCm0sBMRYgh5EgVFtEhsRjiO27vkBoZd/vn5d3b+XcrjFI9q\nxgXWkc8pUjOB93GMd3zgB9d1unjDSxmhWSHQqOJki+MtOuv/b3ZifUqctIrMxwhHuG1gim4Ma5kR\nWuEkXFgU4B0MW1Ho4TeyjX3s4TDq3zn8ALvZ7q5wX9DqLOHCDA95cFBAnOO1AL/ZdNopgY3fQcqF\nyriMe37hM9w521ZkkvlMo7o/8g7nZYQ/QDctp1nTCf0AAAAASUVORK5CYII=\n",zoom:"data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABmJLR0QA/wD/AP+gvaeTAAAACXBI\nWXMAAAsTAAALEwEAmpwYAAAAB3RJTUUH3gMPDiIRPL/2oQAAANBJREFUOMvF0b9KgzEcheHHVnCT\nKoI4uXbtLXgB3oJDJxevw1VwkoJ/NjepQ2/BrZRCx0ILFURQKV2kyOeSQpAmn7WDB0Lg955zEhLy\n2scdXlBggits+4WOQqjAJ3qYR7NGLrwXGU9+sGbEtlIF18FwmuBngZ+nCt6CIacC3Rx8LSl4xzgF\nn0tusBn4UyVhuA/7ZYIv5g+pE3ail25hN/qdmzCfpsJVjKKCZesDBwtzrAqGOMQj6vhCDRsY4ALH\nmOVObltR/xeG/jph6OD2r+Fv5lZBWEhMx58AAAAASUVORK5CYII=\n",brush:"data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABmJLR0QA/wD/AP+gvaeTAAAACXBI\nWXMAAEQkAABEJAFAZ8RUAAAAB3RJTUUH3gMCEiQKB9YaAgAAAWtJREFUOMuN0r1qVVEQhuFn700k\nnfEvBq0iNiIiOKXgH4KCaBeIhWARK/EibLwFCwVLjyAWaQzRGG9grC3URkHUBKKgRuWohWvL5pjj\nyTSLxcz7rZlZHyMiItqzFxGTEVF18/UoODNFxDIO4x12dkXqTcBPsCUzD+AK3ndFqhHwEsYz82gn\nN4dbmMRK9R/4KY7jAvbiWmYeHBT5Z4QCP8J1rGAeN3GvU3Mbl/Gq3qCDcxjLzOV+v78fq/iFIxFx\nPyJ2lNJpfBy2g59YzMyzEbEVLzGBJjOriLiBq5gaJrCIU3hcRCbwAtuwjm/Yg/V6I9NgDA1OR8RC\nZq6Vcd7iUwtn5h8fdMBdETGPE+Xe4ExELDRNs4bX2NfCUHe+7UExyfkCP8MhzOA7PuAkvrbwXyNF\nxF3MDqxiqlhXC7SPdaOKiN14g0u4g3H0MvOiTUSNY3iemb0ywmfMdfYyUmAJ2yPiBx6Wr/oy2Oqw\n+A1SupBzAOuE/AAAAABJRU5ErkJggg==\n"},O.Grid=f,f.prototype=Object.create(A.prototype),f.prototype.constructor=f,f.prototype.requiredProps=["xy"],f.prototype.defaultProps={color:"gray",dasharray:"2,2",alpha:"0.5",nticks:10,gridOn:!0,tickvalues:null,zorder:0},f.prototype.draw=function(){this.grid=e.svg.axis().scale(this.scale).orient(this.position).ticks(this.props.nticks).tickValues(this.props.tickvalues).tickSize(this.tickSize,0,0).tickFormat(""),this.elem=this.ax.axes.append("g").attr("class",this.cssclass).attr("transform",this.transform).call(this.grid),O.insert_css("div#"+this.ax.fig.figid+" ."+this.cssclass+" .tick",{stroke:this.props.color,"stroke-dasharray":this.props.dasharray,"stroke-opacity":this.props.alpha}),O.insert_css("div#"+this.ax.fig.figid+" ."+this.cssclass+" path",{"stroke-width":0})},f.prototype.zoomed=function(){this.elem.call(this.grid)},O.Axis=l,l.prototype=Object.create(A.prototype),l.prototype.constructor=l,l.prototype.requiredProps=["position"],l.prototype.defaultProps={nticks:10,tickvalues:null,tickformat:null,fontsize:"11px",fontcolor:"black",axiscolor:"black",scale:"linear",grid:{},zorder:0},l.prototype.getGrid=function(){var e={nticks:this.props.nticks,zorder:this.props.zorder,tickvalues:this.props.tickvalues,xy:this.props.xy};if(this.props.grid)for(var t in this.props.grid)e[t]=this.props.grid[t];return new f(this.ax,e)},l.prototype.draw=function(){this.props.tickvalues?tick_labels=e.scale.threshold().domain(this.props.tickvalues.slice(1)).range(this.props.tickformat):tick_labels=null,this.axis=e.svg.axis().scale(this.scale).orient(this.props.position).ticks(this.props.nticks).tickValues(this.props.tickvalues).tickFormat(tick_labels),this.elem=this.ax.baseaxes.append("g").attr("transform",this.transform).attr("class",this.cssclass).call(this.axis),O.insert_css("div#"+this.ax.fig.figid+" ."+this.cssclass+" line, "+" ."+this.cssclass+" path",{"shape-rendering":"crispEdges",stroke:this.props.axiscolor,fill:"none"}),O.insert_css("div#"+this.ax.fig.figid+" ."+this.cssclass+" text",{"font-family":"sans-serif","font-size":this.props.fontsize,fill:this.props.fontcolor,stroke:"none"})},l.prototype.zoomed=function(){if(this.props.tickvalues!=null){var e=this.axis.scale().domain();this.axis.tickValues(this.props.tickvalues.filter(function(t){return t>=e[0]&&t<=e[1]}))}this.elem.call(this.axis)},O.Coordinates=c,c.prototype.xy=function(e,t,n){return t=typeof t=="undefined"?0:t,n=typeof n=="undefined"?1:n,[this.x(e[t]),this.y(e[n])]},c.prototype.x_data=function(e){return this.ax.x(e)},c.prototype.y_data=function(e){return this.ax.y(e)},c.prototype.x_display=function(e){return e},c.prototype.y_display=function(e){return e},c.prototype.x_axes=function(e){return e*this.ax.width},c.prototype.y_axes=function(e){return this.ax.height*(1-e)},c.prototype.x_figure=function(e){return e*this.fig.width-this.ax.position[0]},c.prototype.y_figure=function(e){return(1-e)*this.fig.height-this.ax.position[1]},O.Path=h,h.prototype=Object.create(A.prototype),h.prototype.constructor=h,h.prototype.requiredProps=["data"],h.prototype.defaultProps={xindex:0,yindex:1,coordinates:"data",facecolor:"green",edgecolor:"black",edgewidth:1,dasharray:"none",pathcodes:null,offset:null,offsetcoordinates:"data",alpha:1,zorder:1},h.prototype.nanFilter=function(e,t){return!isNaN(e[this.props.xindex])&&!isNaN(e[this.props.yindex])},h.prototype.draw=function(){this.datafunc.defined(this.nanFilter.bind(this)).x(function(e){return this.pathcoords.x(e[this.props.xindex])}).y(function(e){return this.pathcoords.y(e[this.props.yindex])}),this.path=this.ax.axes.append("svg:path").attr("d",this.datafunc(this.data,this.pathcodes)).attr("class","mpld3-path").style("stroke",this.props.edgecolor).style("stroke-width",this.props.edgewidth).style("stroke-dasharray",this.props.dasharray).style("stroke-opacity",this.props.alpha).style("fill",this.props.facecolor).style("fill-opacity",this.props.alpha).attr("vector-effect","non-scaling-stroke");if(this.props.offset!==null){var e=this.offsetcoords.xy(this.props.offset);this.path.attr("transform","translate("+e+")")}},h.prototype.elements=function(e){return this.path},h.prototype.zoomed=function(){this.pathcoords.zoomable&&this.path.attr("d",this.datafunc(this.data,this.pathcodes));if(this.props.offset!==null&&this.offsetcoords.zoomable){var e=this.offsetcoords.xy(this.props.offset);this.path.attr("transform","translate("+e+")")}},O.PathCollection=p,p.prototype=Object.create(A.prototype),p.prototype.constructor=p,p.prototype.requiredProps=["paths","offsets"],p.prototype.defaultProps={xindex:0,yindex:1,pathtransforms:[],pathcoordinates:"display",offsetcoordinates:"data",offsetorder:"before",edgecolors:["#000000"],edgewidths:[1],facecolors:["#0000FF"],alphas:[1],zorder:2},p.prototype.transformFunc=function(t,n){var r=this.props.pathtransforms,i=r.length==0?"":e.transform("matrix("+o(r,n)+")").toString(),s=t===null||typeof t=="undefined"?"translate(0, 0)":"translate("+this.offsetcoords.xy(t,this.props.xindex,this.props.yindex)+")";return this.props.offsetorder==="after"?i+s:s+i},p.prototype.pathFunc=function(e,t){return u().x(function(e){return this.pathcoords.x(e[0])}.bind(this)).y(function(e){return this.pathcoords.y(e[1])}.bind(this)).apply(this,o(this.props.paths,t))},p.prototype.styleFunc=function(e,t){var n={stroke:o(this.props.edgecolors,t),"stroke-width":o(this.props.edgewidths,t),"stroke-opacity":o(this.props.alphas,t),fill:o(this.props.facecolors,t),"fill-opacity":o(this.props.alphas,t)},r="";for(var i in n)r+=i+":"+n[i]+";";return r},p.prototype.draw=function(){this.group=this.ax.axes.append("svg:g"),this.pathsobj=this.group.selectAll("paths").data(this.offsets).enter().append("svg:path").attr("d",this.pathFunc.bind(this)).attr("class","mpld3-path").attr("transform",this.transformFunc.bind(this)).attr("style",this.styleFunc.bind(this)).attr("vector-effect","non-scaling-stroke")},p.prototype.elements=function(e){return this.group.selectAll("path")},p.prototype.zoomed=function(){this.props.pathcoordinates==="data"&&this.pathsobj.attr("d",this.pathFunc.bind(this)),this.props.offsetcoordinates==="data"&&this.pathsobj.attr("transform",this.transformFunc.bind(this))},O.Line=d,d.prototype=Object.create(h.prototype),d.prototype.constructor=d,d.prototype.requiredProps=["data"],d.prototype.defaultProps={xindex:0,yindex:1,coordinates:"data",color:"salmon",linewidth:2,dasharray:"none",alpha:1,zorder:2},O.Markers=v,v.prototype=Object.create(p.prototype),v.prototype.constructor=v,v.prototype.requiredProps=["data"],v.prototype.defaultProps={xindex:0,yindex:1,coordinates:"data",facecolor:"salmon",edgecolor:"black",edgewidth:1,alpha:1,markersize:6,markername:"circle",markerpath:null,zorder:3},v.prototype.pathFunc=function(e,t){return this.marker},O.Image=m,m.prototype=Object.create(A.prototype),m.prototype.constructor=m,m.prototype.requiredProps=["data","extent"],m.prototype.defaultProps={alpha:1,coordinates:"data",zorder:1},m.prototype.draw=function(){this.image=this.ax.axes.append("svg:image").attr("class","mpld3-image").attr("xlink:href","data:image/png;base64,"+this.props.data).style({opacity:this.props.alpha}).attr("preserveAspectRatio","none"),this.zoomed()},m.prototype.elements=function(t){return e.select(this.image)},m.prototype.zoomed=function(){var e=this.props.extent;this.image.attr("x",this.coords.x(e[0])).attr("y",this.coords.y(e[3])).attr("width",this.coords.x(e[1])-this.coords.x(e[0])).attr("height",this.coords.y(e[2])-this.coords.y(e[3]))},O.Text=g,g.prototype=Object.create(A.prototype),g.prototype.constructor=g,g.prototype.requiredProps=["text","position"],g.prototype.defaultProps={coordinates:"data",h_anchor:"start",v_baseline:"auto",rotation:0,fontsize:11,color:"black",alpha:1,zorder:3},g.prototype.draw=function(){this.props.coordinates=="data"?this.obj=this.ax.axes.append("text"):this.obj=this.ax.baseaxes.append("text"),this.obj.attr("class","mpld3-text").text(this.text).style("text-anchor",this.props.h_anchor).style("dominant-baseline",this.props.v_baseline).style("font-size",this.props.fontsize).style("fill",this.props.color).style("opacity",this.props.alpha),this.applyTransform()},g.prototype.elements=function(t){return e.select(this.obj)},g.prototype.applyTransform=function(){var e=this.coords.xy(this.position);this.obj.attr("x",e[0]).attr("y",e[1]),this.props.rotation&&this.obj.attr("transform","rotate("+this.props.rotation+","+e+")")},g.prototype.zoomed=function(){this.coords.zoomable&&this.applyTransform()},O.Axes=y,y.prototype=Object.create(A.prototype),y.prototype.constructor=y,y.prototype.requiredProps=["xlim","ylim"],y.prototype.defaultProps={bbox:[.1,.1,.8,.8],axesbg:"#FFFFFF",axesbgalpha:1,gridOn:!1,xdomain:null,ydomain:null,xscale:"linear",yscale:"linear",zoomable:!0,axes:[{position:"left"},{position:"bottom"}],lines:[],paths:[],markers:[],texts:[],collections:[],sharex:[],sharey:[],images:[]},y.prototype.draw=function(){for(var t=0;t<this.props.sharex.length;t++)this.sharex.push(O.get_element(this.props.sharex[t]));for(var t=0;t<this.props.sharey.length;t++)this.sharey.push(O.get_element(this.props.sharey[t]));this.zoom=e.behavior.zoom(),this.zoom.last_t=this.zoom.translate(),this.zoom.last_s=this.zoom.scale(),this.zoom_x=e.behavior.zoom().x(this.xdom),this.zoom_y=e.behavior.zoom().y(this.ydom),this.baseaxes=this.fig.canvas.append("g").attr("transform","translate("+this.position[0]+","+this.position[1]+")").attr("width",this.width).attr("height",this.height).attr("class","mpld3-baseaxes"),this.clip=this.baseaxes.append("svg:clipPath").attr("id",this.clipid).append("svg:rect").attr("x",0).attr("y",0).attr("width",this.width).attr("height",this.height),this.axes=this.baseaxes.append("g").attr("class","mpld3-axes").attr("clip-path","url(#"+this.clipid+")"),this.axesbg=this.axes.append("svg:rect").attr("width",this.width).attr("height",this.height).attr("class","mpld3-axesbg").style("fill",this.props.axesbg).style("fill-opacity",this.props.axesbgalpha);for(var t=0;t<this.elements.length;t++)this.elements[t].draw()},y.prototype.enable_zoom=function(){this.props.zoomable&&(this.zoom.on("zoom",this.zoomed.bind(this,!0)),this.axes.call(this.zoom),this.axes.style("cursor","move"))},y.prototype.disable_zoom=function(){this.props.zoomable&&(this.zoom.on("zoom",null),this.axes.on(".zoom",null),this.axes.style("cursor",null))},y.prototype.zoomed=function(e){e=typeof e=="undefined"?!0:e;if(e){var t=this.zoom.translate()[0]-this.zoom.last_t[0],n=this.zoom.translate()[1]-this.zoom.last_t[1],r=this.zoom.scale()/this.zoom.last_s;this.zoom_x.translate([this.zoom_x.translate()[0]+t,0]),this.zoom_x.scale(this.zoom_x.scale()*r),this.zoom_y.translate([0,this.zoom_y.translate()[1]+n]),this.zoom_y.scale(this.zoom_y.scale()*r),this.zoom.last_t=this.zoom.translate(),this.zoom.last_s=this.zoom.scale(),this.sharex.forEach(function(e){e.zoom_x.translate(this.zoom_x.translate()).scale(this.zoom_x.scale())}.bind(this)),this.sharey.forEach(function(e){e.zoom_y.translate(this.zoom_y.translate()).scale(this.zoom_y.scale())}.bind(this)),this.sharex.forEach(function(e){e.zoomed(!1)}),this.sharey.forEach(function(e){e.zoomed(!1)})}for(var i=0;i<this.elements.length;i++)this.elements[i].zoomed()},y.prototype.reset=function(e,t){this.set_axlim(this.props.xdomain,this.props.ydomain,e,t)},y.prototype.set_axlim=function(t,n,r,o){t=s(t)?this.xdom.domain():t,n=s(n)?this.ydom.domain():n,r=s(r)?750:r,o=i(o)?!0:o;var u=this.props.xscale==="date"?O.interpolateDates(this.xdom.domain(),t):e.interpolate(this.xdom.domain(),t),a=this.props.yscale==="date"?O.interpolateDates(this.ydom.domain(),n):e.interpolate(this.ydom.domain(),n),f=function(e){this.zoom_x.x(this.xdom.domain(u(e))),this.zoom_y.y(this.ydom.domain(a(e))),this.zoomed(!1)}.bind(this);e.select({}).transition().duration(r).tween("zoom",function(){return f}),o&&(this.sharex.forEach(function(e){e.set_axlim(t,null,r,!1)}),this.sharey.forEach(function(e){e.set_axlim(null,n,r,!1)})),this.zoom.scale(1).translate([0,0]),this.zoom.last_t=this.zoom.translate(),this.zoom.last_s=this.zoom.scale(),this.zoom_x.scale(1).translate([0,0]),this.zoom_y.scale(1).translate([0,0])},O.Toolbar=b,b.prototype=Object.create(A.prototype),b.prototype.constructor=b,b.prototype.defaultProps={buttons:["reset","move"]},b.prototype.addButton=function(e){this.buttons.push(new e(this))},b.prototype.draw=function(){function t(){this.buttonsobj.transition(750).attr("y",0)}function n(){this.buttonsobj.transition(750).delay(250).attr("y",16)}O.insert_css("div#"+this.fig.figid+" .mpld3-toolbar image",{cursor:"pointer",opacity:.2,display:"inline-block",margin:"0px"}),O.insert_css("div#"+this.fig.figid+" .mpld3-toolbar image.active",{opacity:.4}),O.insert_css("div#"+this.fig.figid+" .mpld3-toolbar image.pressed",{opacity:.6}),this.fig.canvas.on("mouseenter",t.bind(this)).on("mouseleave",n.bind(this)).on("touchenter",t.bind(this)).on("touchstart",t.bind(this)),this.toolbar=this.fig.canvas.append("svg:svg").attr("width",16*this.buttons.length).attr("height",16).attr("x",2).attr("y",this.fig.height-16-2).attr("class","mpld3-toolbar"),this.buttonsobj=this.toolbar.append("svg:g").selectAll("buttons").data(this.buttons).enter().append("svg:image").attr("class",function(e){return e.cssclass}).attr("xlink:href",function(e){return e.icon()}).attr("width",16).attr("height",16).attr("x",function(e,t){return t*16}).attr("y",16).on("click",function(e){e.click()}).on("mouseenter",function(){e.select(this).classed({active:1})}).on("mouseleave",function(){e.select(this).classed({active:0})});for(var r=0;r<this.buttons.length;r++)this.buttons[r].onDraw()},b.prototype.deactivate_all=function(){this.buttons.forEach(function(e){e.deactivate()})},b.prototype.deactivate_by_action=function(e){function t(t){return e.indexOf(t)!==-1}e.length>0&&this.buttons.forEach(function(e){e.actions.filter(t).length>0&&e.deactivate()})},O.Button=w,w.prototype=Object.create(A.prototype),w.prototype.constructor=w,w.prototype.setState=function(e){e?this.activate():this.deactivate()},w.prototype.click=function(){this.active?this.deactivate():this.activate()},w.prototype.activate=function(){this.toolbar.deactivate_by_action(this.actions),this.onActivate(),this.active=!0,this.toolbar.toolbar.select("."+this.cssclass).classed({pressed:!0}),this.sticky||this.deactivate()},w.prototype.deactivate=function(){this.onDeactivate(),this.active=!1,this.toolbar.toolbar.select("."+this.cssclass).classed({pressed:!1})},w.prototype.sticky=!1,w.prototype.actions=[],w.prototype.icon=function(){return""},w.prototype.onActivate=function(){},w.prototype.onDeactivate=function(){},w.prototype.onDraw=function(){},O.ButtonFactory=function(e){function t(e){w.call(this,e,this.buttonID)}if(typeof e.buttonID!="string")throw"ButtonFactory: buttonID must be present and be a string";t.prototype=Object.create(w.prototype),t.prototype.constructor=t;for(var n in e)t.prototype[n]=e[n];return t},O.Plugin=E,E.prototype=Object.create(A.prototype),E.prototype.constructor=E,E.prototype.requiredProps=[],E.prototype.defaultProps={},E.prototype.draw=function(){},O.ResetPlugin=S,O.register_plugin("reset",S),S.prototype=Object.create(E.prototype),S.prototype.constructor=S,S.prototype.requiredProps=[],S.prototype.defaultProps={},O.ZoomPlugin=x,O.register_plugin("zoom",x),x.prototype=Object.create(E.prototype),x.prototype.constructor=x,x.prototype.requiredProps=[],x.prototype.defaultProps={button:!0,enabled:null},x.prototype.activate=function(){this.fig.enable_zoom()},x.prototype.deactivate=function(){this.fig.disable_zoom()},x.prototype.draw=function(){this.props.enabled?this.fig.enable_zoom():this.fig.disable_zoom()},O.BoxZoomPlugin=T,O.register_plugin("boxzoom",T),T.prototype=Object.create(E.prototype),T.prototype.constructor=T,T.prototype.requiredProps=[],T.prototype.defaultProps={button:!0,enabled:null},T.prototype.activate=function(){this.enable&&this.enable()},T.prototype.deactivate=function(){this.disable&&this.disable()},T.prototype.draw=function(){function e(e){if(this.enabled){var n=t.extent();t.empty()||e.set_axlim([n[0][0],n[1][0]],[n[0][1],n[1][1]])}e.axes.call(t.clear())}O.insert_css("#"+this.fig.figid+" rect.extent."+this.extentClass,{fill:"#fff","fill-opacity":0,stroke:"#999"});var t=this.fig.getBrush();this.enable=function(){this.fig.showBrush(this.extentClass),t.on("brushend",e.bind(this)),this.enabled=!0},this.disable=function(){this.fig.hideBrush(this.extentClass),this.enabled=!1},this.toggle=function(){this.enabled?this.disable():this.enable()},this.disable()},O.TooltipPlugin=N,O.register_plugin("tooltip",N),N.prototype=Object.create(E.prototype),N.prototype.constructor=N,N.prototype.requiredProps=["id"],N.prototype.defaultProps={labels:null,hoffset:0,voffset:10,location:"mouse"},N.prototype.draw=function(){function t(e,t){this.tooltip.style("visibility","visible").text(s===null?"("+e+")":o(s,t))}function n(t,n){if(u==="mouse"){var r=e.mouse(this.fig.canvas.node());this.x=r[0]+this.props.hoffset,this.y=r[1]-this.props.voffset}this.tooltip.attr("x",this.x).attr("y",this.y)}function r(e,t){this.tooltip.style("visibility","hidden")}var i=O.get_element(this.props.id,this.fig),s=this.props.labels,u=this.props.location;this.tooltip=this.fig.canvas.append("text").attr("class","mpld3-tooltip-text").attr("x",0).attr("y",0).text("").style("visibility","hidden"),u=="bottom left"||u=="top left"?(this.x=i.ax.position[0]+5+this.props.hoffset,this.tooltip.style("text-anchor","beginning")):u=="bottom right"||u=="top right"?(this.x=i.ax.position[0]+i.ax.width-5+this.props.hoffset,this.tooltip.style("text-anchor","end")):this.tooltip.style("text-anchor","middle");if(u=="bottom left"||u=="bottom right")this.y=i.ax.position[1]+i.ax.height-5+this.props.voffset;else if(u=="top left"||u=="top right")this.y=i.ax.position[1]+5+this.props.voffset;i.elements().on("mouseover",t.bind(this)).on("mousemove",n.bind(this)).on("mouseout",r.bind(this))},O.LinkedBrushPlugin=C,O.register_plugin("linkedbrush",C),C.prototype=Object.create(O.Plugin.prototype),C.prototype.constructor=C,C.prototype.requiredProps=["id"],C.prototype.defaultProps={button:!0,enabled:null},C.prototype.activate=function(){this.enable&&this.enable()},C.prototype.deactivate=function(){this.disable&&this.disable()},C.prototype.draw=function(){function t(t){h!=this&&(e.select(h).call(a.clear()),h=this,a.x(t.xdom).y(t.ydom))}function n(e){var t=f[e.axnum];if(t.length>0){var n=t[0].props.xindex,r=t[0].props.yindex,i=a.extent();a.empty()?c.selectAll("path").classed("mpld3-hidden",!1):c.selectAll("path").classed("mpld3-hidden",function(e){return i[0][0]>e[n]||i[1][0]<e[n]||i[0][1]>e[r]||i[1][1]<e[r]})}}function r(e){a.empty()&&c.selectAll("path").classed("mpld3-hidden",!1)}var i=O.get_element(this.props.id);if(i===null)throw"LinkedBrush: no object with id='"+this.props.id+"' was found";var s=this.fig;if(!("offsets"in i.props))throw"Plot object with id='"+this.props.id+"' is not a scatter plot";var o="offsets"in i.props?"offsets":"data";
O.insert_css("#"+s.figid+" rect.extent."+this.extentClass,{fill:"#000","fill-opacity":.125,stroke:"#fff"}),O.insert_css("#"+s.figid+" path.mpld3-hidden",{stroke:"#ccc !important",fill:"#ccc !important"});var u="mpld3data-"+i.props[o],a=s.getBrush(),f=[];s.axes.forEach(function(e){var t=[];e.elements.forEach(function(e){e.props[o]===i.props[o]&&(e.group.classed(u,!0),t.push(e))}),f.push(t)});var l=[],c=s.canvas.selectAll("."+u),h;this.enable=function(){this.fig.showBrush(this.extentClass),a.on("brushstart",t).on("brush",n).on("brushend",r),this.enabled=!0},this.disable=function(){e.select(h).call(a.clear()),this.fig.hideBrush(this.extentClass),this.enabled=!1},this.disable()},O.register_plugin("mouseposition",k),k.prototype=Object.create(O.Plugin.prototype),k.prototype.constructor=k,k.prototype.requiredProps=[],k.prototype.defaultProps={fontsize:12,fmt:".3g"},k.prototype.draw=function(){var t=this.fig,n=e.format(this.props.fmt),r=t.canvas.append("text").attr("class","mpld3-coordinates").style("text-anchor","end").style("font-size",this.props.fontsize).attr("x",this.fig.width-5).attr("y",this.fig.height-5);for(var i=0;i<this.fig.axes.length;i++){var s=function(){var s=t.axes[i];return function(){var t=e.mouse(this),i=s.x.invert(t[0]),o=s.y.invert(t[1]);r.text("("+n(i)+", "+n(o)+")")}}();t.axes[i].baseaxes.on("mousemove",s).on("mouseout",function(){r.text("")})}},O.Figure=L,L.prototype=Object.create(A.prototype),L.prototype.constructor=L,L.prototype.requiredProps=["width","height"],L.prototype.defaultProps={data:{},axes:[],plugins:[{type:"reset"},{type:"zoom"},{type:"boxzoom"}]},L.prototype.getBrush=function(){if(typeof this._brush=="undefined"){var t=e.svg.brush().x(e.scale.linear()).y(e.scale.linear());this.root.selectAll(".mpld3-axes").data(this.axes).call(t),this.axes.forEach(function(e){t.x(e.xdom).y(e.ydom),e.axes.call(t)}),this._brush=t,this.hideBrush()}return this._brush},L.prototype.showBrush=function(e){e=typeof e=="undefined"?"":e;var t=this.getBrush();t.on("brushstart",function(e){t.x(e.xdom).y(e.ydom)}),this.canvas.selectAll("rect.background").style("cursor","crosshair").style("pointer-events",null),this.canvas.selectAll("rect.extent, rect.resize").style("display",null).classed(e,!0)},L.prototype.hideBrush=function(e){e=typeof e=="undefined"?"":e;var t=this.getBrush();t.on("brushstart",null).on("brush",null).on("brushend",function(e){e.axes.call(t.clear())}),this.canvas.selectAll("rect.background").style("cursor",null).style("pointer-events","visible"),this.canvas.selectAll("rect.extent, rect.resize").style("display","none").classed(e,!1)},L.prototype.add_plugin=function(e){var n=e.type;if(typeof n=="undefined"){console.warn("unspecified plugin type. Skipping this");return}e=t(e),delete e.type,n in O.plugin_map&&(n=O.plugin_map[n]);if(typeof n!="function"){console.warn("Skipping unrecognized plugin: "+n);return}e.clear_toolbar&&(this.props.toolbar=[]);if("buttons"in e)if(typeof e.buttons=="string")this.props.toolbar.push(e.buttons);else for(var r=0;r<e.buttons.length;r++)this.props.toolbar.push(e.buttons[r]);this.plugins.push(new n(this,e))},L.prototype.draw=function(){this.canvas=this.root.append("svg:svg").attr("class","mpld3-figure").attr("width",this.width).attr("height",this.height);for(var e=0;e<this.axes.length;e++)this.axes[e].draw();this.disable_zoom();for(var e=0;e<this.plugins.length;e++)this.plugins[e].draw();this.toolbar.draw()},L.prototype.reset=function(e){this.axes.forEach(function(t){t.reset(e,!1)})},L.prototype.enable_zoom=function(){for(var e=0;e<this.axes.length;e++)this.axes[e].enable_zoom();this.zoom_on=!0},L.prototype.disable_zoom=function(){for(var e=0;e<this.axes.length;e++)this.axes[e].disable_zoom();this.zoom_on=!1},L.prototype.toggle_zoom=function(){this.zoom_on?this.disable_zoom():this.enable_zoom()},L.prototype.get_data=function(e){return e===null||typeof e=="undefined"?null:typeof e=="string"?this.data[e]:e},O.PlotElement=A,A.prototype.requiredProps=[],A.prototype.defaultProps={},A.prototype.processProps=function(e){e=t(e);var n={},r=this.name();this.requiredProps.forEach(function(t){if(!(t in e))throw"property '"+t+"' "+"must be specified for "+r;n[t]=e[t],delete e[t]});for(var i in this.defaultProps)i in e?(n[i]=e[i],delete e[i]):n[i]=this.defaultProps[i];"id"in e?(n.id=e.id,delete e.id):"id"in n||(n.id=O.generateId());for(var i in e)console.warn("Unrecognized property '"+i+"' "+"for object "+this.name()+" (value = "+e[i]+").");return n},A.prototype.name=function(){var e=/function (.{1,})\(/,t=e.exec(this.constructor.toString());return t&&t.length>1?t[1]:""},typeof module=="object"&&module.exports?module.exports=O:this.mpld3=O,console.log("Loaded mpld3 version "+O.version)}(d3);